<?
/*
 *    	sqlCached : permet d'utiliser phpCached avec Mysql.
 *		Version: 0.1 Beta 		
*/

# This file is part of phpCached.
# Copyright (c) 2005 Stephane Depierrepont (toorop@cyborgnation.org). 
# All rights reserved.
#
# phpCached is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# phpCached is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with phpCached; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

require_once('phpCached.class.php');

class sqlCached extends phpCached {
	private $db_base=false;								# Base		
	private $db_host=false;								# Hote MySQL
	private $db_login=false;							# Login MySQL
	private $db_passwd=false;							# Mot de passe MySQL	
	private $use_persistants_mysql_connexions=false;	# Connexion pesrsitante ?
	private $db_link=false;								# Lien MySQL	
	private $db_result=false;							# Result
	
	/* Constructeur */
	function __construct($cache_dir=false,$db_base=false,$db_host=false,$db_login=false,$db_passwd=false,$use_persistants_mysql_connexions=false){
		parent::__construct($cache_dir);

		if ($db_base==false) throw new Exception('$db_base not set');
		$this->db_base=$db_base;

		if (!$db_host) throw new Exception('$db_host not set');
		$this->db_host=$db_host;	
		
		if (!$db_login)throw new Exception('$db_login not set');
		$this->db_login=$db_login;		
		
		if (!$db_passwd) throw new Exception('$db_passwd not set','sqlCached init problem.');
		$this->db_passwd=$db_passwd;		
		
		$this->use_persistants_mysql_connexions=$use_persistants_mysql_connexions;			
		unset($db_base,$db_host,$db_login,$db_passwd,$use_persistants_mysql_connexions);		
		return true;					
	}
	
	/* Destructeur */
	function __destruct() {
		if ($this->db_link) @mysql_close($this->db_link);
		if ($this->db_result!=false) @mysql_free_result($this->db_result);
		return true;		
	}
	
	
	/*
	------------------
	Methodes publiques
	------------------
	*/
	
	/**
	* query($requete,$cached_time=0)	
	* @return Array result
	* @param string $requete : requete a executer
	* @param int $cached_time : nombre de secondes ou la requete doit etre cachee
	* si ce parametre est a zero la requete n'est pas cachee
	* @desc Execute la requete et retourne un tableau obtenu avec mysql_
	
	
	*/
	public function query($requete,$cached_time=0){		
		$t_row=array();
		/* On verifie si la requete est compatible */
		if(stristr($requete, 'select') === false) throw new Exception('SQLCache works only with SELECT command.');
		if ($cached_time==0) return $this->_sqlQuery($requete);
		/* On regarde si on a un resultat cachee */
		$t_row=$this->getFromCache($this->getHash($requete),$cached_time);
		if($t_row===false){
			/* On fait un requete, sur sql normale */
			$t_row=$this->_sqlQuery($requete);
			/* et on met le resultat en cache */
			$this->putInCache($this->getHash($requete),$t_row);	
		}		
		return $t_row;		
	}
	
	

	
	/*
	 * 	Methodes privees
	 */
	
	/**
	 * Execute la requete ver sle serveur MySQL
	 *
	 * @param string $requete
	 * @return array
	 */
	private function _sqlQuery($requete){
		$t_row=array();
		/* On regarde si on est connecte au serveur MySQL */
		if (!$this->db_link){
			if ($this->use_persistants_mysql_connexions)$this->db_link=@mysql_pconnect($this->db_host, $this->db_login,$this->db_passwd);
			else $this->db_link=@mysql_connect($this->db_host,$this->db_login,$this->db_passwd);	
			if (!$this->db_link)throw new Exception('MySQL AUTH failed in mysqlCached->_sqlQuery');
		} else mysql_ping($this->db_link);
		
		/* On execute la requete */
		if (!mysql_select_db($this->db_base))throw new Exception('MySQL Failure :'.mysql_error());
		$result=mysql_query($requete);
		if($result===false) throw new Exception('MySQL Failure :'.mysql_error());
		
		/* On transforme le resultat en tableau */
		if (mysql_num_fields($result)!=0){
			while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) $t_row[]=$row;
		}
		
		/* Si on n'utilise pas de connexions persistantes on se deconnecte */
		if (!$this->use_persistants_mysql_connexions and $this->db_link){@mysql_close($this->db_link);$this->db_link=false;};
		return $t_row;		
	}
}


?>
